package Server_Client.NetWorkGame;

import UI.GameState.*;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Scanner;

public class Client1 {
    private Socket socket = null;
    private String host;
    private int port;
    private int myX, myY, myRotate;
    private ArrayList<BulletState> myBullets;
    private WallState wallState;
    private String serverAns;
    private String[] enemyComponents;
    private int numOfEnemies;
    private String wallMap;

    public Client1(String address , int port) {
        this.host = address;
        this.port = port;
        numOfEnemies = 0;
    }



    public void run(TankState tankState) {
        try{
            socket = new Socket(host,port);
            OutputStream out = socket.getOutputStream();
            InputStream in = socket.getInputStream();

            out.write("Client1".getBytes());
            String clientText = "";

            boolean running = true;
            do {
                clientText = myTankComponents();
                running = !clientText.equalsIgnoreCase("over");
                out.write(clientText.getBytes());

                byte[] buffer = new byte[2048];
                int read = in.read(buffer);
                serverAns  = new String(buffer,0,read);
                System.out.println("- From Server : "+serverAns);
            }while(running);

            System.out.println("Client disconnected.");
            socket.close();
        }catch (IOException e){
            System.out.println("Error : "+e.getMessage());
            e.printStackTrace();
        }
    }

    private int getNumOfEnemies(){
        String[] s = serverAns.split(" ");
        numOfEnemies = s.length/6;
        return numOfEnemies;
    }

    public ArrayList<EnemyTank> createEnemyTanks(){
        ArrayList<EnemyTank> enemyTanks = new ArrayList<>();
        for (int i = 0 ; i < getNumOfEnemies() ; i ++){
            EnemyTank enemyTank = new EnemyTank(wallState);
            enemyTanks.add(enemyTank);
        }
        return enemyTanks;
    }

    public void updateEnemyComponents(ArrayList<EnemyTank> enemyTanks){//ToDO separate tanks and each tank bullets
        int j = 0;
        enemyComponents = serverAns.split(" ");
        wallMap = enemyComponents[0];
        for (int i = 1 ; i < getNumOfEnemies() ; i++){
            enemyTanks.get(i).locX = Integer.parseInt(enemyComponents[j]);j++;
            enemyTanks.get(i).locY = Integer.parseInt(enemyComponents[j]);j++;
            enemyTanks.get(i).rotate = Integer.parseInt(enemyComponents[j]);j++;
            for (BulletState bullet : enemyTanks.get(i).getBullets()){
                bullet.locX = Integer.parseInt(enemyComponents[j]);j++;
                bullet.locY = Integer.parseInt(enemyComponents[j]);j++;
            }
        }
    }


    public void updateMyTank (TankState myTank) throws IOException {
        myX = myTank.locX;
        myY = myTank.locY;
        myRotate = myTank.rotate;
        myBullets = myTank.getBullets();
    }

    private String myTankComponents(){
        String tankComponent , bulletComponent = "";
        tankComponent = myX +" "+ myY +" " + myRotate ;
        for (BulletState bullet : myBullets){
            bulletComponent +=" " + bullet.locX + " " + bullet.locY ;
        }
        return tankComponent+bulletComponent;
    }

    public WallState getWallState() {
        wallState.setSource(wallMap);
        return wallState;
    }
}
